Loading...
Searching...
No Matches
SalesforceRestDataProvider Namespace Reference

Qore SalesforceRestDataProvider module definition. More...

## Classes

class | SalesforceRestDataProvider
| The SalesforceRest data provider class. More...
class | SalesforceRestDataProviderFactory
| The SalesforceRest data provider factory. More...
class | SalesforceRestObjectDataProvider
| The SalesforceRestObjectDataProvider data provider class. More...
class | SalesforceRestRecordIterator
| Defines the record iterator class for Table-based iterators. More...
struct | SoqlColumnOperatorInfo
| column operator info hash as returned by all column operator functions More...
struct | SoqlOperatorInfo
| SOQL operator info hash as returned by all operator functions. More...

## Functions

hash< SoqlColumnOperatorInfo > | soql_cop_avg (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"avg"` operator; returns average column values More...
hash< SoqlColumnOperatorInfo > | soql_cop_calendar_month (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"calendar_month"` function; returns the calendar month for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_calendar_quarter (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"calendar_quarter"` function; returns the calendar quarter for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_calendar_year (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"calendar_year"` function; returns the calendar year for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_convert_currency (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"convertCurrency"` operator; returns the given column value in the default currency for the current user More...
hash< SoqlColumnOperatorInfo > | soql_cop_count (auto column='')
| returns a SoqlColumnOperatorInfo hash for the `"count"` aggregate function; returns row counts More...
hash< SoqlColumnOperatorInfo > | soql_cop_count_distinct (auto column='')
| returns a SoqlColumnOperatorInfo hash for the `"count_distinct"` aggregate function; returns row counts More...
hash< SoqlColumnOperatorInfo > | soql_cop_day_in_month (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"day_in_month"` function; returns the day in the month for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_day_in_week (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"day_in_week"` function; returns the day in the week for a date or date/time value (1 = Sunday, 7 = Saturday) More...
hash< SoqlColumnOperatorInfo > | soql_cop_day_in_year (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"day_in_year"` function; returns the day in the year for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_day_only (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"day_only"` function; returns the date from a date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_fiscal_month (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"fiscal_month"` function; returns the fiscal month for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_fiscal_quarter (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"fiscal_quarter"` function; returns the fiscal quarter for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_fiscal_year (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"fiscal_year"` function; returns the fiscal year for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_format (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"format"` operator; returns the given column value in the default locale for number, date, time, and currency fields More...
hash< SoqlColumnOperatorInfo > | soql_cop_hour_in_day (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"hour_in_day"` function; returns the hextern in the day for a date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_max (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"max"` operator; returns maximum column values More...
hash< SoqlColumnOperatorInfo > | soql_cop_min (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"min"` operator; returns minimum column values More...
hash< SoqlColumnOperatorInfo > | soql_cop_sum (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"sum"` operator; returns the total sum of a numeric column. More...
hash< SoqlColumnOperatorInfo > | soql_cop_week_in_month (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"week_in_month"` function; returns the week in the month for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_cop_week_in_year (auto column)
| returns a SoqlColumnOperatorInfo hash for the `"week_in_m=year"` function; returns the week in the year for a date or date/time value More...
hash< SoqlColumnOperatorInfo > | soql_make_cop (string cop, auto column, auto arg)
| returns a SoqlColumnOperatorInfo hash More...
hash< SoqlOperatorInfo > | soql_make_op (string op, auto arg)
| returns an SoqlOperatorInfo hash
hash< SoqlOperatorInfo > | soql_op_eq (auto arg)
| returns an SoqlOperatorInfo hash for the `"="` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values More...
hash< SoqlOperatorInfo > | soql_op_ge (auto arg)
| returns an SoqlOperatorInfo hash for the `">="` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values More...
hash< SoqlOperatorInfo > | soql_op_gt (auto arg)
| returns an SoqlOperatorInfo hash for the `">"` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values More...
hash< SoqlOperatorInfo > | soql_op_in ()
| returns an SoqlOperatorInfo hash for the `"in"` operator with all arguments passed to the function; for use in salesforce where clauses More...
hash< SoqlOperatorInfo > | soql_op_in (list< auto > args)
| returns an SoqlOperatorInfo hash for the `"in"` operator with the given argument list as the first argument; for use in salesforce where clauses More...
hash< SoqlOperatorInfo > | soql_op_le (auto arg)
| returns an SoqlOperatorInfo hash for the `"<="` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values More...
hash< SoqlOperatorInfo > | soql_op_like (string str)
| returns an SoqlOperatorInfo hash for the `"like"` operator with the given argument for use in salesforce where clauses More...
hash< SoqlOperatorInfo > | soql_op_lt (auto arg)
| returns an SoqlOperatorInfo hash for the `"<"` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values More...
hash< SoqlOperatorInfo > | soql_op_ne (auto arg)
| returns an SoqlOperatorInfo hash for the `"!="` or `"<>"` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values More...
hash< SoqlOperatorInfo > | soql_op_not (hash arg)
| returns an SoqlOperatorInfo hash for the `"not"` operator; for use in salesforce where clauses More...
hash< SoqlOperatorInfo > | soql_op_not_in ()
| returns an SoqlOperatorInfo hash for the `"not in"` operator with all arguments passed to the function; for use in salesforce where clauses More...
hash< SoqlOperatorInfo > | soql_op_not_in (list< auto > args)
| returns an SoqlOperatorInfo hash for the `"not in"` operator with the given argument list as the first argument; for use in salesforce where clauses More...
hash< string, hash< SoqlOperatorInfo > > | soql_wop_or (hash< auto > h1, hash< auto > h2)
| returns an SoqlOperatorInfo hash with a fake `"_OR_"` column name; the list of arguments to the function is combined such that each hash in the list generates SQL expressions combined with "and" logic, and each of those clauses is combined with "or" logic; this is for use in salesforce where clauses More...

## Variables

const | DefaultSoqlCopMap
| a hash of default column operator descriptions
const | DefaultSoqlOpMap
| a hash of valid operators for use in where clauses
hashdecl | SalesforceRestRecordInfo
| contains Salesforce object record information
const | SOQL_COP_AVG = "avg"
| to return the average value More...
const | SOQL_COP_CALENDAR_MONTH = "calendar_month"
| to return the calendar month of a date or date/time value More...
const | SOQL_COP_CALENDAR_QUARTER = "calendar_quarter"
| to return the calendar quarter of a date or date/time value More...
const | SOQL_COP_CALENDAR_YEAR = "calendar_year"
| to return the calendar year of a date or date/time value More...
const | SOQL_COP_CONVERT_CURRENCY = "convert_currency"
| to return the given column value in the default currency for the calling user More...
const | SOQL_COP_COUNT = "count"
| to return the row count More...
const | SOQL_COP_COUNT_DISTINCT = "count_distinct"
| to return a count of distinct values More...
const | SOQL_COP_DAY_IN_MONTH = "day_in_month"
| to return the day in a month of a date or date/time value More...
const | SOQL_COP_DAY_IN_WEEK = "day_in_week"
| to return the day in the week of a date or date/time value (1 = Sunday, 7 = Saturday) More...
const | SOQL_COP_DAY_IN_YEAR = "day_in_year"
| to return the day in the year of a date or date/time value More...
const | SOQL_COP_DAY_ONLY = "day_only"
| to return the date from a date/time value More...
const | SOQL_COP_FISCAL_MONTH = "fiscal_month"
| to return the fiscal month of a date or date/time value More...
const | SOQL_COP_FISCAL_QUARTER = "fiscal_quarter"
| to return the fiscal quarter of a date or date/time value More...
const | SOQL_COP_FISCAL_YEAR = "fiscal_year"
| to return the fiscal year of a date or date/time value More...
const | SOQL_COP_FORMAT = "format"
| to return the given column value in the default locale for number, date, time, and currency fields More...
const | SOQL_COP_HOUR_IN_DAY = "hour_in_day"
| to return the hextern in the day of a date/time value More...
const | SOQL_COP_MAX = "max"
| to return the maximum value More...
const | SOQL_COP_MIN = "min"
| to return the minimum value More...
const | SOQL_COP_SUM = "sum"
| to return the sum value More...
const | SOQL_COP_WEEK_IN_MONTH = "week_in_month"
| to return the week in the month of a date or date/time value More...
const | SOQL_COP_WEEK_IN_YEAR = "week_in_year"
| to return the week in the year of a date or date/time value More...
const | SOQL_OP_EQ = "="
| the SOQL equals operator (=) for use in where clauses More...
const | SOQL_OP_GE = ">="
| the SOQL greater than or equals operator (>=) for use in where clauses More...
const | SOQL_OP_GT = ">"
| the SOQL greater than operator (>) for use in where clauses More...
const | SOQL_OP_IN = "in"
| the SOQL in operator for use in where clauses More...
const | SOQL_OP_LE = "<="
| the SOQL less than or equals (<=) operator for use in where clauses More...
const | SOQL_OP_LIKE = "like"
| like operator
const | SOQL_OP_LT = "<"
| the SOQL less than (<) operator for use in where clauses More...
const | SOQL_OP_NE = "!="
| the SOQL not equals operator (!= or <>) for use in where clauses More...
const | SOQL_OP_NOT = "not"
| the SOQL `"not"` operator for use in where clauses More...
const | SOQL_OP_NOT_IN = "not in"
| the SOQL in operator for use in where clauses More...
const | SOQL_OP_OR = "or"
| to combine SOQL expressions with `"or"` for use in where clauses More...

## Detailed Description

Qore SalesforceRestDataProvider module definition.

Qore SalesforceRestRecordIterator class definition.

Qore SalesforceRestDataProviderFactory class definition.

Qore SalesforceRestDataProviderDefs definitions.

contains all public definitions in the SalesforceRestDataProvider module

SalesforceRestDataProvider.qc Copyright 2022 Qore Technologies, s.r.o.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. contains all public definitions in the SalesforceRestDataProvider module

SalesforceRestDataProviderDefs.qc Copyright 2019 - 2022 Qore Technologies, s.r.o.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. contains all public definitions in the SalesforceRestDataProvider module

SalesforceRestDataProviderFactory.qc Copyright 2022 Qore Technologies, s.r.o.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. Contains all public definitions in the SalesforceRestDataProvider module

SalesforceRestObjectDataProvider.qc Copyright 2019 - 2022 Qore Technologies, s.r.o.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. contains all public definitions in the SalesforceRestDataProvider module

SalesforceRestRecordIterator.qc Copyright 2019 - 2022 Qore Technologies, s.r.o.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. contains all public definitions in the SalesforceRestDataProvider module

## Function Documentation

## soql_cop_avg()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_avg | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"avg"` operator; returns average column values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": (soql_cop_avg("quantity")), "where": {"OrderType": "wholesale"}});

Parameters

  column | the column specification for the column

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_calendar_month()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_calendar_month | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"calendar_month"` function; returns the calendar month for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_calendar_month("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_calendar_quarter()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_calendar_quarter | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"calendar_quarter"` function; returns the calendar quarter for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_calendar_quarter("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_calendar_year()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_calendar_year | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"calendar_year"` function; returns the calendar year for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_calendar_year("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_convert_currency()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_convert_currency | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"convertCurrency"` operator; returns the given column value in the default currency for the current user

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {soql_cop_convert_currency("AnnualRevenue")}, "where": {"OrderType": "wholesale"}});

Parameters

  column | the column specification for the column

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_count()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_count | ( | auto | column = `''` | ) |

returns a SoqlColumnOperatorInfo hash for the `"count"` aggregate function; returns row counts

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_count()}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_count_distinct()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_count_distinct | ( | auto | column = `''` | ) |

returns a SoqlColumnOperatorInfo hash for the `"count_distinct"` aggregate function; returns row counts

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_count_distinct()}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_day_in_month()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_day_in_month | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"day_in_month"` function; returns the day in the month for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_day_in_month("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_day_in_week()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_day_in_week | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"day_in_week"` function; returns the day in the week for a date or date/time value (1 = Sunday, 7 = Saturday)

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_day_in_week("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_day_in_year()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_day_in_year | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"day_in_year"` function; returns the day in the year for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_day_in_year("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_day_only()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_day_only | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"day_only"` function; returns the date from a date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_day_only("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_fiscal_month()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_fiscal_month | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"fiscal_month"` function; returns the fiscal month for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_fiscal_month("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_fiscal_quarter()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_fiscal_quarter | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"fiscal_quarter"` function; returns the fiscal quarter for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_fiscal_quarter("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_fiscal_year()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_fiscal_year | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"fiscal_year"` function; returns the fiscal year for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_fiscal_year("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_format()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_format | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"format"` operator; returns the given column value in the default locale for number, date, time, and currency fields

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {soql_cop_format("Quantity")}, "where": {"OrderType": "wholesale"}});

Parameters

  column | the column specification for the column

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

Note
  using this function on a date or date/time field will cause it to be returned as a string instead of a date/time value

## soql_cop_hour_in_day()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_hour_in_day | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"hour_in_day"` function; returns the hextern in the day for a date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_hour_in_day("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_max()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_max | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"max"` operator; returns maximum column values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": (soql_cop_max("id")), "where": {"Type": "user"}});

Parameters

  column | the column specification for the column

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_min()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_min | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"min"` operator; returns minimum column values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": (soql_cop_min("Id")), "where": {"Type": "user"}});

Parameters

  column | the column specification for the column

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_sum()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_sum | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"sum"` operator; returns the total sum of a numeric column.

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": (soql_cop_sum("quantity")), "where": {"OrderType": "wholesale"}});

Parameters

  column | the column specification for the column

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_week_in_month()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_week_in_month | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"week_in_month"` function; returns the week in the month for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_week_in_month("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_cop_week_in_year()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_cop_week_in_year | ( | auto | column | ) |

returns a SoqlColumnOperatorInfo hash for the `"week_in_m=year"` function; returns the week in the year for a date or date/time value

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"columns": {"AccountType", soql_cop_week_in_year("OrderDate")}, "where": {"Type": "user"}, "groupby": "AccountType"});

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the `"columns"` argument of a search option hash

## soql_make_cop()

hash< SoqlColumnOperatorInfo > SalesforceRestDataProvider::soql_make_cop | ( | string | cop,
|  | auto | column,
|  | auto | arg
| ) |  |

returns a SoqlColumnOperatorInfo hash

Parameters

  cop | the column operator (one of SOQL Column Operators)
  column | the column name
  arg | the argument to the operator

Returns
  a SoqlColumnOperatorInfo hash corresponding to the arguments for use in the columns argument of a search option hash

Note
  Normally this function is not called directly, but rather by the other column operator functions

## soql_op_eq()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_eq | ( | auto | arg | ) |

returns an SoqlOperatorInfo hash for the `"="` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_eq("Smith")});

Parameters

  arg | the argument for the operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

## soql_op_ge()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_ge | ( | auto | arg | ) |

returns an SoqlOperatorInfo hash for the `">="` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_ge("Apple")});

Parameters

  arg | the argument for the operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

## soql_op_gt()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_gt | ( | auto | arg | ) |

returns an SoqlOperatorInfo hash for the `">"` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_gt("Apple")});

Parameters

  arg | the argument for the operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

## soql_op_in() [1/2]

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_in | ( |  | ) |

returns an SoqlOperatorInfo hash for the `"in"` operator with all arguments passed to the function; for use in salesforce where clauses

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_in(200, 300, 500, 9)});

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

Note
  The argument list size may be constrained depending on the database server / driver used; passing a large number of arguments to this function may be a sign of an improper application or query design

## soql_op_in() [2/2]

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_in | ( | list< auto > | args | ) |

returns an SoqlOperatorInfo hash for the `"in"` operator with the given argument list as the first argument; for use in salesforce where clauses

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"name": soql_op_in(idlist)});

Parameters

  args | a list of values for the `"in"` operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

Note
  The argument list size may be constrained depending on the database server / driver used; passing a large number of arguments to this function may be a sign of an improper application or query design

## soql_op_le()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_le | ( | auto | arg | ) |

returns an SoqlOperatorInfo hash for the `"<="` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_le("Zebra")});

Parameters

  arg | the argument for the operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

## soql_op_like()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_like | ( | string | str | ) |

returns an SoqlOperatorInfo hash for the `"like"` operator with the given argument for use in salesforce where clauses

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_like("%smith%")});

Parameters

  str | the argument for the operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

## soql_op_lt()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_lt | ( | auto | arg | ) |

returns an SoqlOperatorInfo hash for the `"<"` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_lt("Zebra")});

Parameters

  arg | the argument for the operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

## soql_op_ne()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_ne | ( | auto | arg | ) |

returns an SoqlOperatorInfo hash for the `"!="` or `"<>"` operator with the given argument for use in salesforce where clauses when comparing column values to immediate values

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_ne("Smith")});

Parameters

  arg | the argument for the operator

## soql_op_not()

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_not | ( | hash | arg | ) |

returns an SoqlOperatorInfo hash for the `"not"` operator; for use in salesforce where clauses

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"name": soql_op_not(soql_op_in(200, 300, 500, 9))))_;

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

## soql_op_not_in() [1/2]

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_not_in | ( |  | ) |

returns an SoqlOperatorInfo hash for the `"not in"` operator with all arguments passed to the function; for use in salesforce where clauses

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Name": soql_op_not_in(200, 300, 500, 9)});

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

Note
  The argument list size may be constrained depending on the database server / driver used; passing a large number of arguments to this function may be a sign of an improper application or query design

## soql_op_not_in() [2/2]

hash< SoqlOperatorInfo > SalesforceRestDataProvider::soql_op_not_in | ( | list< auto > | args | ) |

returns an SoqlOperatorInfo hash for the `"not in"` operator with the given argument list as the first argument; for use in salesforce where clauses

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"name": soql_op_not_in(idlist)});

Parameters

  args | a list of values for the `"not in"` operator

Returns
  an SoqlOperatorInfo hash for use in salesforce where clauses

Note
  The argument list size may be constrained depending on the database server / driver used; passing a large number of arguments to this function may be a sign of an improper application or query design

## soql_wop_or()

hash< string, hash< SoqlOperatorInfo > > SalesforceRestDataProvider::soql_wop_or | ( | hash< auto > | h1,
|  | hash< auto > | h2
| ) |  |

returns an SoqlOperatorInfo hash with a fake `"_OR_"` column name; the list of arguments to the function is combined such that each hash in the list generates SQL expressions combined with "and" logic, and each of those clauses is combined with "or" logic; this is for use in salesforce where clauses

Example:
  AbstractDataProviderRecordIterator i = provider.searchRecords({"Id": id} + soql_wop_or({"Type": "C", "ValidationFlag": soql_op_ne("Y")}, {"ExpirationFlag": 'Y'}));
  Generates:

      select ... from Account where Id = '0012A000022K3zxQAC' and ((type = 'C' and ValidationFlag != 'Y') or (ExpirationFlag = 'Y'))

Parameters

  h1 | the first hash of expressions to combine with `"or"` logic
  h2 | the second hash of expressions to combine with `"or"` logic
  ... | remaining expressions to combine with `"or"` logic

Returns
  a hash with an SoqlOperatorInfo hash value keyed by a fake column name (`"_OR_"` with a numeric prefix for uniqueness) for use in a where operation description hash for use in salesforce where clauses

Note
  a random prefix is used so that multiple uses of the function can be used to generate a single where clause hash

## Variable Documentation

## SOQL_COP_AVG

const SalesforceRestDataProvider::SOQL_COP_AVG = "avg"

to return the average value

See also
  soql_cop_avg

## SOQL_COP_CALENDAR_MONTH

const SalesforceRestDataProvider::SOQL_COP_CALENDAR_MONTH = "calendar_month"

to return the calendar month of a date or date/time value

See also
  soql_cop_calendar_month

## SOQL_COP_CALENDAR_QUARTER

const SalesforceRestDataProvider::SOQL_COP_CALENDAR_QUARTER = "calendar_quarter"

to return the calendar quarter of a date or date/time value

See also
  soql_cop_calendar_quarter

## SOQL_COP_CALENDAR_YEAR

const SalesforceRestDataProvider::SOQL_COP_CALENDAR_YEAR = "calendar_year"

to return the calendar year of a date or date/time value

See also
  soql_cop_calendar_year

## SOQL_COP_CONVERT_CURRENCY

const SalesforceRestDataProvider::SOQL_COP_CONVERT_CURRENCY = "convert_currency"

to return the given column value in the default currency for the calling user

See also
  soql_cop_convert_currency

## SOQL_COP_COUNT

const SalesforceRestDataProvider::SOQL_COP_COUNT = "count"

to return the row count

See also
  soql_cop_count

## SOQL_COP_COUNT_DISTINCT

const SalesforceRestDataProvider::SOQL_COP_COUNT_DISTINCT = "count_distinct"

to return a count of distinct values

See also
  soql_cop_count_distinct

## SOQL_COP_DAY_IN_MONTH

const SalesforceRestDataProvider::SOQL_COP_DAY_IN_MONTH = "day_in_month"

to return the day in a month of a date or date/time value

See also
  soql_cop_day_in_month

## SOQL_COP_DAY_IN_WEEK

const SalesforceRestDataProvider::SOQL_COP_DAY_IN_WEEK = "day_in_week"

to return the day in the week of a date or date/time value (1 = Sunday, 7 = Saturday)

See also
  soql_cop_day_in_week

## SOQL_COP_DAY_IN_YEAR

const SalesforceRestDataProvider::SOQL_COP_DAY_IN_YEAR = "day_in_year"

to return the day in the year of a date or date/time value

See also
  soql_cop_day_in_year

## SOQL_COP_DAY_ONLY

const SalesforceRestDataProvider::SOQL_COP_DAY_ONLY = "day_only"

to return the date from a date/time value

See also
  soql_cop_day_only

## SOQL_COP_FISCAL_MONTH

const SalesforceRestDataProvider::SOQL_COP_FISCAL_MONTH = "fiscal_month"

to return the fiscal month of a date or date/time value

See also
  soql_cop_fiscal_month

## SOQL_COP_FISCAL_QUARTER

const SalesforceRestDataProvider::SOQL_COP_FISCAL_QUARTER = "fiscal_quarter"

to return the fiscal quarter of a date or date/time value

See also
  soql_cop_fiscal_quarter

## SOQL_COP_FISCAL_YEAR

const SalesforceRestDataProvider::SOQL_COP_FISCAL_YEAR = "fiscal_year"

to return the fiscal year of a date or date/time value

See also
  soql_cop_fiscal_year

## SOQL_COP_FORMAT

const SalesforceRestDataProvider::SOQL_COP_FORMAT = "format"

to return the given column value in the default locale for number, date, time, and currency fields

See also
  soql_cop_format

## SOQL_COP_HOUR_IN_DAY

const SalesforceRestDataProvider::SOQL_COP_HOUR_IN_DAY = "hour_in_day"

to return the hextern in the day of a date/time value

See also
  soql_cop_hour_in_day

## SOQL_COP_MAX

const SalesforceRestDataProvider::SOQL_COP_MAX = "max"

to return the maximum value

See also
  soql_cop_max

## SOQL_COP_MIN

const SalesforceRestDataProvider::SOQL_COP_MIN = "min"

to return the minimum value

See also
  soql_cop_min

## SOQL_COP_SUM

const SalesforceRestDataProvider::SOQL_COP_SUM = "sum"

to return the sum value

See also
  soql_cop_sum

## SOQL_COP_WEEK_IN_MONTH

const SalesforceRestDataProvider::SOQL_COP_WEEK_IN_MONTH = "week_in_month"

to return the week in the month of a date or date/time value

See also
  soql_cop_week_in_month

## SOQL_COP_WEEK_IN_YEAR

const SalesforceRestDataProvider::SOQL_COP_WEEK_IN_YEAR = "week_in_year"

to return the week in the year of a date or date/time value

See also
  soql_cop_week_in_year

## SOQL_OP_EQ

const SalesforceRestDataProvider::SOQL_OP_EQ = "="

the SOQL equals operator (=) for use in where clauses

See also
  soql_op_eq()

## SOQL_OP_GE

const SalesforceRestDataProvider::SOQL_OP_GE = ">="

the SOQL greater than or equals operator (>=) for use in where clauses

See also
  soql_op_ge()

## SOQL_OP_GT

const SalesforceRestDataProvider::SOQL_OP_GT = ">"

the SOQL greater than operator (>) for use in where clauses

See also
  soql_op_gt()

## SOQL_OP_IN

const SalesforceRestDataProvider::SOQL_OP_IN = "in"

the SOQL in operator for use in where clauses

See also
  soql_op_in()

## SOQL_OP_LE

const SalesforceRestDataProvider::SOQL_OP_LE = "<="

the SOQL less than or equals (<=) operator for use in where clauses

See also
  soql_op_le()

## SOQL_OP_LT

const SalesforceRestDataProvider::SOQL_OP_LT = "<"

the SOQL less than (<) operator for use in where clauses

See also
  soql_op_lt()

## SOQL_OP_NE

const SalesforceRestDataProvider::SOQL_OP_NE = "!="

the SOQL not equals operator (!= or <>) for use in where clauses

See also
  soql_op_ne()

## SOQL_OP_NOT

const SalesforceRestDataProvider::SOQL_OP_NOT = "not"

the SOQL `"not"` operator for use in where clauses

See also
  soql_op_not()

## SOQL_OP_NOT_IN

const SalesforceRestDataProvider::SOQL_OP_NOT_IN = "not in"

the SOQL in operator for use in where clauses

See also
  soql_op_not_in()

## SOQL_OP_OR

const SalesforceRestDataProvider::SOQL_OP_OR = "or"

to combine SOQL expressions with `"or"` for use in where clauses

See also
  soql_wsoql_op_or()